## ants 1.9+svn532

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)
#Change PROJECT_NAME to the name of your project
PROJECT(ANTS)


OPTION(USE_ITK "Use ITK Libraries" ON)
OPTION(USE_VTK "Use VTK Libraries" OFF)

set (CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
  
FIND_PATH(VTK_DIR UseVTK.cmake $ENV{VTK_DIR} )

# Set up ITK
IF(USE_ITK)
  FIND_PACKAGE(ITK)
  IF(ITK_FOUND)
    INCLUDE(${ITK_USE_FILE})
  ELSE(ITK_FOUND)
    MESSAGE(FATAL_ERROR
      "Cannot build without ITK.  Please set ITK_DIR.")
  ENDIF(ITK_FOUND)
ENDIF(USE_ITK)

# Set up VTK
IF(USE_VTK)
  FIND_PACKAGE(VTK)
  IF(VTK_FOUND)
    INCLUDE(${VTK_USE_FILE})
  ELSE(VTK_FOUND)
     MESSAGE("Cannot build some programs without VTK.  Please set VTK_DIR if you need these programs.")
  ENDIF(VTK_FOUND)
ENDIF(USE_VTK)

#The following lines are required to use Dart
INCLUDE(CTest)
ENABLE_TESTING()


INCLUDE (${CMAKE_ROOT}/Modules/FindITK.cmake) 
IF (USE_ITK_FILE) 
  INCLUDE(${USE_ITK_FILE}) 
ENDIF(USE_ITK_FILE) 


SET(PICSL_INCLUDE_DIRS
../Utilities
../ImageRegistration
../ImageSegmentation
../GraphTheory
../Tensor
../Temporary
)

INCLUDE_DIRECTORIES(${PICSL_INCLUDE_DIRS})

LINK_DIRECTORIES( ${ITK_LIBRARY_PATH} )

# non-templated class -- this should be stored in a library and linked in...
SET(SOURCES "../Utilities/itkCommandLineParser" "../Utilities/itkCommandLineOption" )

ADD_EXECUTABLE(ANTS ANTS.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ANTS ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ANTSJacobian ANTSJacobian.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ANTSJacobian ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(PrintHeader PrintHeader.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(PrintHeader ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ResetDirection ResetDirection.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ResetDirection ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(ResetDirection2 ResetDirection2.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(ResetDirection2 ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(BoykovGraphCutFilter BoykovGraphCutFilter.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(BoykovGraphCutFilter ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(GeneralLinearModel GeneralLinearModel.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(GeneralLinearModel ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(ANTSUseLandmarkImagesToGetAffineTransform ANTSUseLandmarkImagesToGetAffineTransform.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ANTSUseLandmarkImagesToGetAffineTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(ANTSUseDeformationFieldToGetAffineTransform ANTSUseDeformationFieldToGetAffineTransform ${SOURCES})
TARGET_LINK_LIBRARIES(ANTSUseDeformationFieldToGetAffineTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


#ADD_EXECUTABLE(FDR FDR.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(FDR ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ImageMath ImageMath.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ImageMath ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(SurfaceCurvature SurfaceCurvature.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(SurfaceCurvature ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SurfaceBasedSmoothing SurfaceBasedSmoothing.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(SurfaceBasedSmoothing ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )



# ADD_EXECUTABLE(test test.cxx)
#TARGET_LINK_LIBRARIES(test)

#ADD_EXECUTABLE(WarpImage WarpImage.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(WarpImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(LaplacianThickness LaplacianThickness.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(LaplacianThickness ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SetOrigin SetOrigin.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(SetOrigin ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SetSpacing SetSpacing.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(SetSpacing ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SetDirectionByMatrix SetDirectionByMatrix.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(SetDirectionByMatrix ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


#ADD_EXECUTABLE(WarpFunctionalImage WarpFunctionalImage.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(WarpFunctionalImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ConvertScalarImageToRGB ConvertScalarImageToRGB.cxx)
TARGET_LINK_LIBRARIES(ConvertScalarImageToRGB ITKIO)

ADD_EXECUTABLE(CreateWarpedGridImage CreateWarpedGridImage.cxx)
TARGET_LINK_LIBRARIES(CreateWarpedGridImage ITKCommon  ITKBasicFilters ITKIO)

# ADD_EXECUTABLE(CreateJacobianDeterminantImage CreateJacobianDeterminantImage.cxx)
# TARGET_LINK_LIBRARIES(CreateJacobianDeterminantImage ITKCommon  ITKBasicFilters ITKIO)

ADD_EXECUTABLE(MeasureImageSimilarity MeasureImageSimilarity.cxx)
TARGET_LINK_LIBRARIES(MeasureImageSimilarity ITKCommon  ITKBasicFilters ITKIO)

ADD_EXECUTABLE(ConvertToJpg ConvertToJpg.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ConvertToJpg ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ConvertImagePixelType ConvertImagePixelType.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ConvertImagePixelType ITKCommon  ITKBasicFilters ITKIO    )


ADD_EXECUTABLE(AverageImages AverageImages.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(AverageImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(AverageTensorImages AverageTensorImages.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(AverageTensorImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ImageSetStatistics ImageSetStatistics.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ImageSetStatistics ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ThresholdImage ThresholdImage.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ThresholdImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(MultiplyImages MultiplyImages.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(MultiplyImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SmoothImage SmoothImage.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(SmoothImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ClusterImageStatistics ClusterImageStatistics.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(ClusterImageStatistics ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(LabelClustersUniquely LabelClustersUniquely.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(LabelClustersUniquely ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(StudentsTestOnImages StudentsTestOnImages.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(StudentsTestOnImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(LabelOverlapMeasures LabelOverlapMeasures.cxx )
TARGET_LINK_LIBRARIES(LabelOverlapMeasures ITKIO)

ADD_EXECUTABLE(MeasureMinMaxMean MeasureMinMaxMean.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(MeasureMinMaxMean ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(WarpImageMultiTransform WarpImageMultiTransform ${SOURCES})
TARGET_LINK_LIBRARIES(WarpImageMultiTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ComposeMultiTransform ComposeMultiTransform ${SOURCES})
TARGET_LINK_LIBRARIES(ComposeMultiTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(WarpVTKPolyDataMultiTransform WarpVTKPolyDataMultiTransform)
TARGET_LINK_LIBRARIES(WarpVTKPolyDataMultiTransform ITKIO )

ADD_EXECUTABLE(StackSlices StackSlices.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(StackSlices ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(MemoryTest MemoryTest.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(MemoryTest ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(ANTSOrientImage ANTSOrientImage.cxx ${SOURCES})
#TARGET_LINK_LIBRARIES(ANTSOrientImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(PermuteFlipImageOrientationAxes PermuteFlipImageOrientationAxes.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(PermuteFlipImageOrientationAxes ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ImageCompare ImageCompare.cxx)
TARGET_LINK_LIBRARIES(ImageCompare ITKIO)

ADD_EXECUTABLE(ResampleImageBySpacing ResampleImageBySpacing.cxx)
TARGET_LINK_LIBRARIES(ResampleImageBySpacing ITKIO)

#ADD_EXECUTABLE(ResampleImageByOtherImage ResampleImageByOtherImage.cxx)
#TARGET_LINK_LIBRARIES(ResampleImageByOtherImage ITKIO)

ADD_EXECUTABLE(CopyImageHeaderInformation CopyImageHeaderInformation.cxx)
TARGET_LINK_LIBRARIES(CopyImageHeaderInformation ITKIO)

ADD_EXECUTABLE(WarpTimeSeriesImageMultiTransform WarpTimeSeriesImageMultiTransform.cxx)
TARGET_LINK_LIBRARIES(WarpTimeSeriesImageMultiTransform ITKCommon ITKBasicFilters ITKIO ITKNumerics  ITKStatistics)


ADD_EXECUTABLE(WarpTensorImageMultiTransform WarpTensorImageMultiTransform.cxx)
TARGET_LINK_LIBRARIES(WarpTensorImageMultiTransform ITKCommon ITKBasicFilters ITKIO ITKNumerics  ITKStatistics)

ADD_EXECUTABLE(ReorientTensorImage ReorientTensorImage.cxx)
TARGET_LINK_LIBRARIES(ReorientTensorImage ITKCommon ITKBasicFilters ITKIO)

ADD_EXECUTABLE(N3BiasFieldCorrection N3BiasFieldCorrection.cxx)
TARGET_LINK_LIBRARIES(N3BiasFieldCorrection ITKIO ITKStatistics ITKNumerics)

ADD_EXECUTABLE(N4BiasFieldCorrection N4BiasFieldCorrection.cxx  ${SOURCES})
TARGET_LINK_LIBRARIES(N4BiasFieldCorrection ITKIO ITKStatistics)

ADD_EXECUTABLE(KellySlater KellySlater.cxx)
TARGET_LINK_LIBRARIES(KellySlater ITKIO ITKStatistics)

IF (USE_VTK)
INCLUDE (${CMAKE_ROOT}/Modules/FindVTK.cmake)
IF (USE_VTK_FILE)
  INCLUDE(${USE_VTK_FILE})
  ADD_EXECUTABLE(ConvertVectorFieldToVTK ConvertVectorFieldToVTK.cxx )
  TARGET_LINK_LIBRARIES(ConvertVectorFieldToVTK ITKNumerics ITKIO ITKCommon vtkIO)

  ADD_EXECUTABLE(GetMeshAndTopology GetMeshAndTopology.cxx)
  TARGET_LINK_LIBRARIES(GetMeshAndTopology ITKCommon ITKNumerics ITKFEM  ITKIO ITKMetaIO  vtkRendering vtksys vtkIO)

  SET(FLAT_SRC
    ../Temporary/itkFEMElement3DC0LinearTriangular.cxx
    ../Temporary/itkFEMElement3DC0LinearTriangularLaplaceBeltrami.cxx
    ../Temporary/itkFEMElement3DC0LinearTriangularMembrane.cxx
  )
  # Build the library
  ADD_LIBRARY(FLATFEM ${FLAT_SRC})
  TARGET_LINK_LIBRARIES(FLATFEM ITKBasicFilters ITKIO)


  ADD_EXECUTABLE(ConformalMapping ConformalMapping.cxx)
  TARGET_LINK_LIBRARIES(ConformalMapping ITKCommon ITKNumerics ITKFEM FLATFEM ITKIO ITKMetaIO  vtkRendering vtkIO)
  #vtkPatented vtkIO)

  # SRD replace vtkPatented by vtksys
#   ADD_EXECUTABLE(ConformalMappingSphere  ConformalMappingSphere.cxx )
#  TARGET_LINK_LIBRARIES(ConformalMappingSphere ITKCommon ITKNumerics ITKFEM FLATFEM ITKIO ITKMetaIO  vtkRendering vtksys vtkIO)


ENDIF (USE_VTK_FILE)
ENDIF(USE_VTK)



ADD_EXECUTABLE(ANTSIntegrateVectorField ANTSIntegrateVectorField.cxx)
TARGET_LINK_LIBRARIES(ANTSIntegrateVectorField ITKIO ITKStatistics)

SET(SOURCES "../Utilities/itkCommandLineParser" "../Utilities/itkCommandLineOption" )
ADD_EXECUTABLE(Atropos Atropos.cxx ${SOURCES})
TARGET_LINK_LIBRARIES(Atropos ITKCommon  ITKBasicFilters ITKIO ITKStatistics   )



#Set any libraries that your project depends on.
#examples: ITKCommon, VTKRendering, etc
SET(Libraries
ITKIO
)

#SET(CurrentExe "GlamorousGlue")

=== debian/changelog ===
ants (1.9+svn532-5) unstable; urgency=low

  * Disable lengthy _SYN unittest to allow pass on slow archs (like sparc)
    (Closes: #594133). Added few other reasonably fast tests
  * Boosting policy to 3.9.1 -- including BSD-3 verbatim into copyright,
    updating copyright format according to DEP5 rev135

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 23 Aug 2010 17:53:32 -0400

ants (1.9+svn532-4) unstable; urgency=low

  * Cherry picking rev 581,589-590 from upstream to assure correct application
    of transformation while operating on 4D timeseries (Closes: #588195)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 06 Jul 2010 12:34:52 -0400

ants (1.9+svn532-3) unstable; urgency=low

  * Moving under NeuroDebian umbrella
  * Absorbed commits from upstream:
    - avoid division by 0 in progress meter (Closes: #586915)
    - initializer warper ones (prior to the loop) in 
      WarpTimeSeriesImageMultiTransform

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 23 Jun 2010 11:25:16 -0400

ants (1.9+svn532-2) unstable; urgency=low

  * Placing all binaries and scripts under /usr/lib/ants, since many
    scripts rely on binaries to be in the same directory, and ftp-master
    raised concern about some names for the binaries.  ANTS binary only gets
    symlinked under /usr/bin
  * Initial Debian release (Closes: #579569)
  * Added fsl and gridengine-client into suggests

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 01 Jun 2010 13:11:44 -0400

ants (1.9+svn532-1) UNRELEASED; urgency=low

  * Initial packaging

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 28 Apr 2010 13:29:29 -0400

=== debian/control ===
Source: ants
Section: science
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), help2man, cmake, libgdcm2-dev, libopenjpeg-dev, libinsighttoolkit3-dev, libvtk5-dev, uuid-dev
Standards-Version: 3.9.1
Homepage: http://www.picsl.upenn.edu/ANTS/
Vcs-Git: git://git.debian.org/pkg-exppsy/ants.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/ants.git;a=summary

Package: ants
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fsl, gridengine-client
Description: advanced normalization tools for brain and image analysis
 Advanced Normalization Tools (ANTS) is an ITK-based suite of
 normalization, segmentation and template-building tools for
 quantitative morphometric analysis. Many of the ANTS registration
 tools are diffeomorphic, but deformation (elastic and BSpline)
 transformations are available. Unique components of ANTS include
 multivariate similarity metrics, landmark guidance, the ability to
 use label images to guide the mapping and both greedy and space-time
 optimal implementations of diffeomorphisms. The symmetric
 normalization (SyN) strategy is a part of the ANTS toolkit as is
 directly manipulated free form deformation (DMFFD).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Build directory, to don't dig them out later
# on from the bulk since there is no install target in upstream build system
BUILDDIR=$(CURDIR)/build
DESTBINDIR=$(BUILDDIR)/bin

export CFLAGS = -Wall -g
export LDFLAGS = -Wl,--as-needed

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    export CFLAGS += -O0
else
    export CFLAGS += -O2
endif
export CXXFLAGS = $(CFLAGS)

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Default mega-rule
%:
	dh -DExamples $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCOPY_SCRIPT_FILES_TO_BIN_DIR:BOOL=OFF \
		-DCMAKE_SKIP_RPATH:BOOL=ON \
		-DEXECUTABLE_OUTPUT_PATH:PATH=$(DESTBINDIR)

override_dh_auto_build:
	dh_auto_build
	: Build manpages
	cd $(DESTBINDIR) && mkdir ../man && \
    for f in *; do \
	 help2man --name="part of ANTS registration suite" --version-string 1.9 \
	          --no-info --no-discard-stderr ./$$f >| ../man/$$f.1; \
     done

# For now perform only some small subselection of tests since some
# tests are very CPU intensive and some fail and there is no clean way
# to select "good" and quick ones
override_dh_auto_test:
	# debhelper just calls make test so no -R could be passed
	# PATH=$$PATH:$(DESTBINDIR) dh_auto_test -- -R "ANTS_(CC_1|...$$)"
	# thus lets do it manually
	cd obj-*; PATH=$$PATH:$(DESTBINDIR) ctest --force-new-ctest-process -R "ANTS_(CC_1|SYN_|EXP|...$$)" -E "(ANTS_SYN|ANTS_SYN_WITH_TIME)$$"

override_dh_auto_install:
	dh_auto_install
	: Install binaries
	install -t debian/ants/usr/lib/ants $(DESTBINDIR)/*
	: Symlink binaries of primary importance into /usr/bin
	for f in ANTS WarpImageMultiTransform; do \
		dh_link usr/lib/ants/$$f usr/bin/$$f; \
	done
	: Install shell scripts
	install -t debian/ants/usr/lib/ants Scripts/*
	: Install manpages
	dh_installman $(BUILDDIR)/man/*

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

=== debian/watch ===
version=3
opts="uversionmangle=s/pt/./g" http://sf.net/advants/ants(.*)code\.zip

## ants 1.9.2%2Bsvn680.dfsg

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

#Change PROJECT_NAME to the name of your project
PROJECT(ANTS)


OPTION(USE_ITK "Use ITK Libraries" ON)
OPTION(USE_VTK "Use VTK Libraries" OFF)

set (CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
  
FIND_PATH(VTK_DIR UseVTK.cmake $ENV{VTK_DIR} )

# Set up ITK
IF(USE_ITK)
  FIND_PACKAGE(ITK)
  IF(ITK_FOUND)
    INCLUDE(${ITK_USE_FILE})
  ELSE(ITK_FOUND)
    MESSAGE(FATAL_ERROR
      "Cannot build without ITK.  Please set ITK_DIR.")
  ENDIF(ITK_FOUND)
ENDIF(USE_ITK)

# Set up VTK
IF(USE_VTK)
  FIND_PACKAGE(VTK)
  IF(VTK_FOUND)
    INCLUDE(${VTK_USE_FILE})
  ELSE(VTK_FOUND)
     MESSAGE("Cannot build some programs without VTK.  Please set VTK_DIR if you need these programs.")
  ENDIF(VTK_FOUND)
ENDIF(USE_VTK)

#The following lines are required to use Dart
INCLUDE(CTest)
ENABLE_TESTING()


INCLUDE (${CMAKE_ROOT}/Modules/FindITK.cmake) 
IF (USE_ITK_FILE) 
  INCLUDE(${USE_ITK_FILE}) 
ENDIF(USE_ITK_FILE) 

SET(DART_TESTING_TIMEOUT 1500)

SET(PICSL_INCLUDE_DIRS
../Utilities
../ImageRegistration
../ImageSegmentation
../GraphTheory
../Tensor
../Temporary
)

INCLUDE_DIRECTORIES(${PICSL_INCLUDE_DIRS})

LINK_DIRECTORIES( ${ITK_LIBRARY_PATH} )

# non-templated class -- this should be stored in a library and linked in...
SET(UI_SOURCES "../Utilities/antsCommandLineParser" "../Utilities/antsCommandLineOption" )

ADD_EXECUTABLE(ANTS ANTS.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ANTS ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ANTSJacobian ANTSJacobian.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ANTSJacobian ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(PrintHeader PrintHeader.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(PrintHeader ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ResetDirection ResetDirection.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ResetDirection ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(ResetDirection2 ResetDirection2.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(ResetDirection2 ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(BoykovGraphCutFilter BoykovGraphCutFilter.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(BoykovGraphCutFilter ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(GeneralLinearModel GeneralLinearModel.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(GeneralLinearModel ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(ANTSUseLandmarkImagesToGetAffineTransform ANTSUseLandmarkImagesToGetAffineTransform.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ANTSUseLandmarkImagesToGetAffineTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(ANTSUseDeformationFieldToGetAffineTransform ANTSUseDeformationFieldToGetAffineTransform ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ANTSUseDeformationFieldToGetAffineTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


#ADD_EXECUTABLE(FDR FDR.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(FDR ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ImageMath ImageMath.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ImageMath ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(SurfaceCurvature SurfaceCurvature.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(SurfaceCurvature ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SurfaceBasedSmoothing SurfaceBasedSmoothing.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(SurfaceBasedSmoothing ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )



# ADD_EXECUTABLE(test test.cxx)
#TARGET_LINK_LIBRARIES(test)

#ADD_EXECUTABLE(WarpImage WarpImage.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(WarpImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(LaplacianThickness LaplacianThickness.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(LaplacianThickness ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SetOrigin SetOrigin.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(SetOrigin ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SetSpacing SetSpacing.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(SetSpacing ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SetDirectionByMatrix SetDirectionByMatrix.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(SetDirectionByMatrix ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


#ADD_EXECUTABLE(WarpFunctionalImage WarpFunctionalImage.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(WarpFunctionalImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ConvertScalarImageToRGB ConvertScalarImageToRGB.cxx)
TARGET_LINK_LIBRARIES(ConvertScalarImageToRGB ITKIO)

ADD_EXECUTABLE(CreateWarpedGridImage CreateWarpedGridImage.cxx)
TARGET_LINK_LIBRARIES(CreateWarpedGridImage ITKCommon  ITKBasicFilters ITKIO)

# ADD_EXECUTABLE(CreateJacobianDeterminantImage CreateJacobianDeterminantImage.cxx)
# TARGET_LINK_LIBRARIES(CreateJacobianDeterminantImage ITKCommon  ITKBasicFilters ITKIO)

ADD_EXECUTABLE(MeasureImageSimilarity MeasureImageSimilarity.cxx)
TARGET_LINK_LIBRARIES(MeasureImageSimilarity ITKCommon  ITKBasicFilters ITKIO)

ADD_EXECUTABLE(ConvertToJpg ConvertToJpg.cxx)
TARGET_LINK_LIBRARIES(ConvertToJpg ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ConvertImagePixelType ConvertImagePixelType.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ConvertImagePixelType ITKCommon  ITKBasicFilters ITKIO    )


ADD_EXECUTABLE(AverageImages AverageImages.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(AverageImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(AverageTensorImages AverageTensorImages.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(AverageTensorImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ImageSetStatistics ImageSetStatistics.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ImageSetStatistics ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ThresholdImage ThresholdImage.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ThresholdImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(MultiplyImages MultiplyImages.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(MultiplyImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(SmoothImage SmoothImage.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(SmoothImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ClusterImageStatistics ClusterImageStatistics.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ClusterImageStatistics ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(LabelClustersUniquely LabelClustersUniquely.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(LabelClustersUniquely ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(StudentsTestOnImages StudentsTestOnImages.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(StudentsTestOnImages ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(LabelOverlapMeasures LabelOverlapMeasures.cxx )
TARGET_LINK_LIBRARIES(LabelOverlapMeasures ITKIO)

ADD_EXECUTABLE(MeasureMinMaxMean MeasureMinMaxMean.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(MeasureMinMaxMean ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(WarpImageMultiTransform WarpImageMultiTransform ${UI_SOURCES})
TARGET_LINK_LIBRARIES(WarpImageMultiTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ComposeMultiTransform ComposeMultiTransform ${UI_SOURCES})
TARGET_LINK_LIBRARIES(ComposeMultiTransform ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )


ADD_EXECUTABLE(StackSlices StackSlices.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(StackSlices ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(MemoryTest MemoryTest.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(MemoryTest ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

#ADD_EXECUTABLE(ANTSOrientImage ANTSOrientImage.cxx ${UI_SOURCES})
#TARGET_LINK_LIBRARIES(ANTSOrientImage ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(PermuteFlipImageOrientationAxes PermuteFlipImageOrientationAxes.cxx ${UI_SOURCES})
TARGET_LINK_LIBRARIES(PermuteFlipImageOrientationAxes ITKCommon  ITKBasicFilters ITKIO   ITKNumerics  ITKStatistics  ITKFEM )

ADD_EXECUTABLE(ImageCompare ImageCompare.cxx)
TARGET_LINK_LIBRARIES(ImageCompare ITKIO)

ADD_EXECUTABLE(ResampleImageBySpacing ResampleImageBySpacing.cxx)
TARGET_LINK_LIBRARIES(ResampleImageBySpacing ITKIO)

#ADD_EXECUTABLE(ResampleImageByOtherImage ResampleImageByOtherImage.cxx)
#TARGET_LINK_LIBRARIES(ResampleImageByOtherImage ITKIO)

ADD_EXECUTABLE(CopyImageHeaderInformation CopyImageHeaderInformation.cxx)
TARGET_LINK_LIBRARIES(CopyImageHeaderInformation ITKIO)

ADD_EXECUTABLE(WarpTimeSeriesImageMultiTransform WarpTimeSeriesImageMultiTransform.cxx)
TARGET_LINK_LIBRARIES(WarpTimeSeriesImageMultiTransform ITKCommon ITKBasicFilters ITKIO ITKNumerics  ITKStatistics)

ADD_EXECUTABLE(ResampleImage ResampleImage.cxx )
TARGET_LINK_LIBRARIES(ResampleImage ITKNumerics ITKIO ITKCommon)

ADD_EXECUTABLE(ExtractSliceFromImage ExtractSliceFromImage.cxx )
TARGET_LINK_LIBRARIES(ExtractSliceFromImage ITKNumerics ITKIO ITKCommon)

ADD_EXECUTABLE(TileImages TileImages.cxx )
TARGET_LINK_LIBRARIES(TileImages ITKNumerics ITKIO ITKCommon)


ADD_EXECUTABLE(WarpTensorImageMultiTransform WarpTensorImageMultiTransform.cxx)
TARGET_LINK_LIBRARIES(WarpTensorImageMultiTransform ITKCommon ITKBasicFilters ITKIO ITKNumerics  ITKStatistics)

ADD_EXECUTABLE(ReorientTensorImage ReorientTensorImage.cxx)
TARGET_LINK_LIBRARIES(ReorientTensorImage ITKCommon ITKBasicFilters ITKIO)

ADD_EXECUTABLE(N3BiasFieldCorrection N3BiasFieldCorrection.cxx)
TARGET_LINK_LIBRARIES(N3BiasFieldCorrection ITKIO ITKStatistics ITKNumerics)

ADD_EXECUTABLE(N4BiasFieldCorrection N4BiasFieldCorrection.cxx  ${UI_SOURCES})
TARGET_LINK_LIBRARIES(N4BiasFieldCorrection ITKIO ITKStatistics)

ADD_EXECUTABLE(KellySlater KellySlater.cxx)
TARGET_LINK_LIBRARIES(KellySlater ITKIO ITKStatistics)

IF (USE_VTK)
INCLUDE (${CMAKE_ROOT}/Modules/FindVTK.cmake)
IF (USE_VTK_FILE)
  INCLUDE(${USE_VTK_FILE})
  ADD_EXECUTABLE(ConvertVectorFieldToVTK ConvertVectorFieldToVTK.cxx )
  TARGET_LINK_LIBRARIES(ConvertVectorFieldToVTK ITKNumerics ITKIO ITKCommon vtkIO)

  ADD_EXECUTABLE(GetMeshAndTopology GetMeshAndTopology.cxx)
  TARGET_LINK_LIBRARIES(GetMeshAndTopology ITKCommon ITKNumerics ITKFEM  ITKIO ITKMetaIO  vtkRendering vtksys vtkIO)

  ADD_EXECUTABLE(CheckTopology CheckTopology.cxx)
  TARGET_LINK_LIBRARIES(CheckTopology ITKCommon ITKNumerics ITKFEM  ITKIO ITKMetaIO  vtkRendering vtksys vtkIO)

ADD_EXECUTABLE(WarpVTKPolyDataMultiTransform WarpVTKPolyDataMultiTransform)
TARGET_LINK_LIBRARIES(WarpVTKPolyDataMultiTransform ITKIO vtksys vtkIO )


  SET(FLAT_SRC
    ../Temporary/itkFEMElement3DC0LinearTriangular.cxx
    ../Temporary/itkFEMElement3DC0LinearTriangularLaplaceBeltrami.cxx
    ../Temporary/itkFEMElement3DC0LinearTriangularMembrane.cxx
  )
  # Build the library
  ADD_LIBRARY(FLATFEM ${FLAT_SRC})
  TARGET_LINK_LIBRARIES(FLATFEM ITKBasicFilters ITKIO)


  ADD_EXECUTABLE(ConformalMapping ConformalMapping.cxx)
  TARGET_LINK_LIBRARIES(ConformalMapping ITKCommon ITKNumerics ITKFEM FLATFEM ITKIO ITKMetaIO  vtkRendering vtkIO)
 
 ADD_EXECUTABLE(ANTSConformalMapping ANTSConformalMapping.cxx ${UI_SOURCES})

## ants 1.9.2+svn680.dfsg

=== debian/changelog ===
ants (1.9.2+svn680.dfsg-4) unstable; urgency=low

  [ Matthias Klose ]
  * Fix build using GCC 4.7. Closes: #667099.

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 04 May 2012 10:27:15 -0400

ants (1.9.2+svn680.dfsg-3) unstable; urgency=low

  * Seems to build fine now against available ITK 3.20 (Closes: #655306)
  * Boosting policy to 3.9.3 (no changes)
  * Version ITK build-depends >= 3.16~
  * Placed build PATH ahead of system wide during tests so proper version
    of ants gets tested on systems with ants installed
  * (Temporarily) added a bulk of build-depends for wrapper bindings for
    vtk >= 5.8 to overcome #584300

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 09 Mar 2012 13:08:26 -0500

ants (1.9.2+svn680.dfsg-2) unstable; urgency=low

  * Upload to unstable version from experimental (forgotten there).
    Builds fine with ITK 3.20 (Closes: #614483)
  * New patch deb_antspath -- use default path on Debian systems
    (/usr/lib/ants) and do not override with hardcode custom upstream paths
    (Closes: #636529)
  * Boosting policy to 3.9.2 (no changes)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 23 Sep 2011 21:34:43 -0400

ants (1.9.2+svn680.dfsg-1) experimental; urgency=low

  * New upstream release
  * Adding .dfsg since Documentation/ is pruned from source trees
    due to incomplete set of building materials to reproduce PDFs

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 14 Nov 2010 21:24:18 -0500

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,12 @@
 Priority: extra
 Maintainer: NeuroDebian Team <team@neuro.debian.net>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), help2man, cmake, libgdcm2-dev, libopenjpeg-dev, libinsighttoolkit3-dev, libvtk5-dev, uuid-dev
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 7.0.50~), help2man, cmake, libgdcm2-dev, libopenjpeg-dev, libinsighttoolkit3-dev (>= 3.16~), libvtk5-dev, uuid-dev,
+               tcl-vtk | libvtk5-dev (<< 5.8),
+               python-vtk | libvtk5-dev (<< 5.8),
+               libvtk-java | libvtk5-dev (<< 5.8),
+               libvtk5.8-qt4 | libvtk5-dev (<< 5.8)
+Standards-Version: 3.9.3
 Homepage: http://www.picsl.upenn.edu/ANTS/
 Vcs-Git: git://git.debian.org/pkg-exppsy/ants.git
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/ants.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 else
     export CFLAGS += -O2
 endif
-export CXXFLAGS = $(CFLAGS)
+export CXXFLAGS = $(CFLAGS) -fpermissive
 
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
@@ -46,7 +46,7 @@
 	# debhelper just calls make test so no -R could be passed
 	# PATH=$$PATH:$(DESTBINDIR) dh_auto_test -- -R "ANTS_(CC_1|...$$)"
 	# thus lets do it manually
-	cd obj-*; PATH=$$PATH:$(DESTBINDIR) ctest --force-new-ctest-process -R "ANTS_(CC_1|SYN_|EXP|...$$)" -E "(ANTS_SYN|ANTS_SYN_WITH_TIME)$$"
+	cd obj-*; PATH=$(DESTBINDIR):$$PATH ctest --force-new-ctest-process -R "ANTS_(CC_1|SYN_|EXP|...$$)" -E "(ANTS_SYN|ANTS_SYN_WITH_TIME)$$"
 
 override_dh_auto_install:
 	dh_auto_install

=== debian/watch ===
version=3
opts="uversionmangle=s/pt/./g,dversionmangle=s/.dfsg$//" http://sf.net/advants/ants(.*)code\.zip
